#!/usr/bin/perl
#
# This script generates a CSV File usable for MS Excel from
# test data. To convert . to , as expected by german versions
# of Excel pipe it's output through tr like this:
# ./ana-mobility-csv.pl |tr '.' ',' >out.csv
$|=1;
$SPEED=15;

printf("Pauses;PDF;Delay;Routingamount;OptimalRoutes;Routingsizeratio\r\n");
  foreach my $RP (qw(DSDV AODV AODVUU DSR TORA NRLOLSR)){
    print "\"$RP\"\r\n";
    foreach my $PAUSE (100,90,80,70,60,50,40,25,10,0){
      my $sent = 0;
      my $recv = 0;
      my $delay  = 0;
      my $delayc = 0;
			my $rtr_sz  = 0;
			my $rtr_szc = 0;
			my $rtr_opt  = 0;
			my $rtr_optc = 0;
			my $rtr_szratio  = 0;
			my $rtr_szratioc = 0;
      foreach my $RND (1111,5555,7777){
        my $cbr='out2/data/mobility-'.$RP.'-cbr-50n-20c-8.0r-'.$PAUSE.'p-'.$SPEED.'s-'.$RND.'rnd.data';
        my $tcp='out2/data/mobility-'.$RP.'-tcp-50n-20c-8.0r-'.$PAUSE.'p-'.$SPEED.'s-'.$RND.'rnd.data';
				my %vcbr=getdata($cbr);
				my %vtcp=getdata($tcp);
        $sent += $vcbr{data_sent};
        $recv += $vcbr{data_recv};
        if($vtcp{avg_time}){
          $delay += $vtcp{avg_time};
          $delayc++;
        }
				if($vcbr{rtr_size}){
					$rtr_sz += $vcbr{rtr_size};
					$rtr_szc++;
				}
				if($vtcp{rtr_szratio}){
					$rtr_szratio += $vtcp{rtr_szratio};
					$rtr_szratioc++;
				}
				if($vtcp{route_ratio}){
          $rtr_opt += $vtcp{route_ratio};
          $rtr_optc++;
        }
      }
      my $rtr_sz = ($rtr_sz/$rtr_szc);
      my $delay = ($delay/$delayc);
      my $PDF = ($recv/$sent)*100;
			my $rtr_opt = ($rtr_opt/$rtr_optc);
			my $zratio= ($rtr_szratio/$rtr_szratioc);
      printf("%d;%.2f;%.2f;%d;%.2f;%.2f\r\n",$PAUSE,$PDF,$delay,$rtr_sz,$rtr_opt,$rtr_szratio);
    }
    print "\n"
  }
  
sub getdata($){
  my $file = $_[0];
  my %data;

  open (FILE,$file) || die("argh $file");
  my @lines = <FILE>;
  close FILE;

  foreach $line (@lines){
    my ($key,$val) = split(':',$line,2);
                $key =~ s/\s+$//;
                $key =~ s/^\s+//;
                $val =~ s/\s+$//;
                $val =~ s/^\s+//;
                $data{$key}=$val;
  }
        return %data;
}
