#!/usr/bin/perl
#
# This script generates a CSV File usable for MS Excel from
# test data. To convert . to , as expected by german versions
# of Excel pipe it's output through tr like this:
# ./ana-szenarios-csv.pl |tr '.' ',' >out.csv

$|=1;

foreach $SZ (@SZNS){
  print "$SZ\n\n";
  foreach $RP (@RPS){
    %data = getdata("$SZ-$RP-cbr.dat");

        print "$RP\t";
    print $data{data_ratio};
    print "\n";
  }
  print "\n";
}

printf("Name;PDF;Delay;Routingamount;OptimalRoutes;RoutingSizeRatio\r\n");
foreach my $RP (qw(DSDV AODV AODVUU DSR TORA NRLOLSR)){
	print "$RP\r\n";
	foreach my $NAME (qw(kongress unicampus stadtverkehr erdbeben)){
      my $sent = 0;
      my $recv = 0;
      my $delay  = 0;
      my $delayc = 0;
			my $rtr_sz  = 0;
			my $rtr_szc = 0;
			my $rtr_opt  = 0;
			my $rtr_optc = 0;
			my $rtr_szratio  = 0;
			my $rtr_szratioc = 0;
      foreach my $RND (1111,5555,7777){
        my $cbr="szenarios/data/$NAME-$RP-cbr-$RND.dat";
        my $tcp="szenarios/data/$NAME-$RP-tcp-$RND.dat";
				my %vcbr=getdata($cbr);
				my %vtcp=getdata($tcp);
        $sent += $vcbr{data_sent};
        $recv += $vcbr{data_recv};
        if($vtcp{avg_time}){
          $delay += $vtcp{avg_time};
          $delayc++;
        }
				if($vcbr{rtr_size}){
					$rtr_sz += $vcbr{rtr_size};
					$rtr_szc++;
				}
				if($vtcp{rtr_szratio}){
					$rtr_szratio += $vtcp{rtr_szratio};
					$rtr_szratioc++;
				}
				if($vcbr{route_ratio}){
          $rtr_opt += $vcbr{route_ratio};
          $rtr_optc++;
        }
      }
      my $rtr_sz = ($rtr_sz/$rtr_szc) if($rtr_szc);
      my $delay = ($delay/$delayc) if($delayc);
      my $PDF = ($recv/$sent)*100 if($sent);
			my $rtr_opt = ($rtr_opt/$rtr_optc) if($rtr_optc);
			my $zratio= ($rtr_szratio/$rtr_szratioc) if($rtr_szratioc);
      printf("%s;%.2f;%.2f;%d;%.2f;%.2f\r\n",$NAME,$PDF,$delay,$rtr_sz,$rtr_opt,$rtr_szratio);
  }
  print "\n"
}
  
sub getdata($){
  my $file = $_[0];
  my %data;

  open (FILE,$file) || die("argh $file");
  my @lines = <FILE>;
  close FILE;

  foreach $line (@lines){
    my ($key,$val) = split(':',$line,2);
                $key =~ s/\s+$//;
                $key =~ s/^\s+//;
                $val =~ s/\s+$//;
                $val =~ s/^\s+//;
                $data{$key}=$val;
  }
        return %data;
}
