#!/bin/sh

. simulation.conf

NODES=50
SIZE=500
CONS=20
SPEED=15

for PROTO in cbr tcp
do
	for RND in 1111 5555 7777
  do
    for RP in $RPS
    do
      for PAUSE in 100 90 80 70 60 50 40 25 10 0
      do
        MMODEL=`mmodel $NODES $SIZE $PAUSE $RND` 
        TMODEL=`tmodel $NODES $CONS $RND`
        TRACE="$OUTDIR/trace/mobility-$RP-$PROTO-${NODES}n-${CONS}c-${RATE}r-${PAUSE}p-${SPEED}s-${RND}rnd.tr"
        DATA="$OUTDIR/data/mobility-$RP-$PROTO-${NODES}n-${CONS}c-${RATE}r-${PAUSE}p-${SPEED}s-${RND}rnd.data"
        if [ ! -s $TRACE ]; then
          echo "creating $TRACE";
          $NS2BIN $SIMULATION -nn $NODES -x $SIZE -y $SIZE -rp $RP -tm $TMODEL -mm $MMODEL -tr $TRACE
        fi
        #analyze:
        $ANALYZE < $TRACE > $DATA
        #clean up:
        rm -f $TRACE
      done
    done
	done
done
