#!/bin/sh

. simulation.conf

SPEED=15
PAUSE=50

function sim(){
  NODES=$1
  CONS=$2
  SIZE=$3
  RP=$4
  RND=$5
  MMODEL=`mmodel $NODES $SIZE $PAUSE $RND` 
  TMODEL=`tmodel $NODES $CONS $RND`
  TRACE="$OUTDIR/trace/size-$SIZE-$RP-cbr-${NODES}n-${CONS}c-${RATE}r-${PAUSE}p-${RND}rnd.tr"
  DATA="$OUTDIR/data/size-$SIZE-$RP-cbr-${NODES}n-${CONS}c-${RATE}r-${PAUSE}p-${RND}rnd.data"
  if [ ! -s $TRACE ]; then
    echo "creating $TRACE";
    $NS2BIN $SIMULATION -nn $NODES -rp $RP -x $SIZE -y $SIZE -tm $TMODEL -mm $MMODEL -tr $TRACE
  fi
  #analyze
  echo "creating $DATA"
  $ANALYZE < $TRACE > $DATA
  #clean up:
  rm -f $TRACE
}


for RND in 1111 5555 7777
do
  for RP in $RPS
  do
    #   n   con size  rp  rnd
    sim 20  12  350   $RP $RND
    sim 50  30  450   $RP $RND
    sim 80  48  800   $RP $RND
    sim 100 60  1000  $RP $RND
		sim 200 120  1600  $RP $RND
  done
done

