
NS2DIR="/home/andi/projects/diplom/code/downloads/ns-2.26"
NS2BIN="/usr/local/bin/ns"
SETDEST="$NS2DIR/indep-utils/cmu-scen-gen/setdest/setdest"
TRAFFICGEN="./trafficgen.pl"
SIMULATION="simulation.tcl"
ANALYZE="./analyze.pl"
#RPS="DSDV AODV AODVUU TORA DSR NRLOLSR"
RPS="NRLOLSR"

OUT="./szenarios"

function sim(){
  NAME=$1;
  NODES=$2;
  X=$3
  Y=$3
  PROTO=$4
	RND=$5

	if [ ! -s $OUT/models/$NAME-$RND.move ]
	then
  	$SETDEST -n 15 -p 90 -s 3 -t 100 -x 300 -y 300 > $OUT/models/$NAME-$RND.move
	fi
	if [ ! -s $OUT/models/$NAME-$RND.$PROTO ]
  then
    $TRAFFICGEN -i $PROTO -n 15 -t 100 -s $RND -c 15 -r 8 > $OUT/models/$NAME-$RND.$PROTO
  fi

  for RP in $RPS
  do
		echo "$RP $NAME"
    $NS2BIN $SIMULATION -nn $NODES -rp $RP -x $X -y $Y \
    -tm $OUT/models/$NAME-$RND.$PROTO -mm $OUT/models/$NAME-$RND.move \
    -tr $OUT/trace/$NAME-$RP-$PROTO-$RND.tr

    $ANALYZE < $OUT/trace/$NAME-$RP-$PROTO-$RND.tr > $OUT/data/$NAME-$RP-$PROTO-$RND.dat

		rm -f $OUT/trace/$NAME-$RP-$PROTO-$RND.tr

  done
}

for PROTO in cbr tcp
do
  for RND in 1111 5555 7777
  do
  sim kongress     15  300  $PROTO $RND
  sim unicampus    40  500  $PROTO $RND
  sim erdbeben 		 80  1000 $PROTO $RND
  sim stadtverkehr 100 1000 $PROTO $RND
  done
done

